﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;

namespace Hexeditor
{
    public partial class Form1 : Form
    {
        int _tabnr = 0;
       
        int _colSize=16;
        int _fontSize = 10;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {            
            MainTab.Dock = DockStyle.Fill;
            ToolStripMenuItem menuItem2;
            for (int i = 8; i <=46; i += 2)
            {
                menuItem2 = new ToolStripMenuItem(i + " pg");
                menuItem2.Tag = i;
                if (i == 10) menuItem2.Checked = true;
                menuItem2.Click += new System.EventHandler(this.BnSizeColumn_Click);
                BnMainSizeColumn.DropDownItems.Add(menuItem2);
               
            }

            for (int i=2; i<=24; i+=2) {
                menuItem2 = new ToolStripMenuItem(i+" Spalten");
                menuItem2.Tag = i;
                if (i == 16) menuItem2.Checked = true;
                menuItem2.Click += new System.EventHandler(this.BnColumn_Click);
                BnMainColumn.DropDownItems.Add(menuItem2);
                //BnColumn_Click(object sender, EventArgs e)
            }

            Text = "Hex-Editor";
        }

        
      
        private void BnOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter =
               "Bilder (*.bmp,jpg)|*.bmp;*.jpg|DBF-Dateien (*.dbf)|*.dbf|Programme (*.exe)|*.exe|Textdateien (*.txt)|*.txt|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = "";
            openFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                createPanel(openFileDialog1.FileName);
            }
        }

        private void createPanel(String sFilename)
        {
            TabPage tabPage1;
            HexPanel panel1;           
            String sFile = basis.getFilename(sFilename);
            String s = File.GetAttributes(sFilename).ToString();
            
            tabPage1 = new TabPage(sFile);
            panel1 = new HexPanel(Color.White, _fontSize, _colSize, sFilename);
            _tabnr++;
            panel1.Name = "panel" + _tabnr;

            tabPage1.Controls.Add(panel1);
            tabPage1.Name = "tabPage" + _tabnr;
            tabPage1.Padding = new System.Windows.Forms.Padding(3);
            // tabPage1.Text = sFile;
            tabPage1.UseVisualStyleBackColor = true;
            panel1.Dock = DockStyle.Fill;
            MainTab.TabPages.Add(tabPage1);
            if (MainTab.TabPages.Count>0) MainTab.SelectedIndex = MainTab.TabPages.Count - 1;
        }


        private void MnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void BnSizeColumn_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem menuItem2;
            for (int i = 0; i < BnMainSizeColumn.DropDownItems.Count - 1; i++)
            {
                menuItem2 = (ToolStripMenuItem)BnMainSizeColumn.DropDownItems[i];
                menuItem2.Checked = false;
            }
            menuItem2 = (ToolStripMenuItem)sender;
            menuItem2.Checked = true;
            int fontSize = (int)menuItem2.Tag;
            if (fontSize >= 0)
            {
                _fontSize = fontSize;
                HexPanel panel;
                foreach (TabPage page in MainTab.TabPages)
                {
                    panel = (HexPanel)page.GetNextControl(page, true);
                    panel.fontSize = _fontSize;
                    panel.Invalidate();
                }
            }
        }

        private void BnColumn_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem menuItem2;
            for (int i = 0; i < BnMainColumn.DropDownItems.Count - 1; i++)
            {
                menuItem2 = (ToolStripMenuItem)BnMainColumn.DropDownItems[i];
                menuItem2.Checked = false;
            }

            menuItem2 = (ToolStripMenuItem)sender;
            menuItem2.Checked = true;
            int colSize = (int)menuItem2.Tag;
            if (colSize > 0)
            {
                _colSize = colSize;
                HexPanel panel;
                foreach (TabPage page in MainTab.TabPages)
                {
                    panel = (HexPanel)page.GetNextControl(page, true);
                    panel.colSize = colSize;
                    panel.Invalidate();
                }
            }

        }


        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {            
            int i = MainTab.SelectedIndex;
            if ((i >= 0) && (MainTab.TabPages.Count > 0))
            {
                TabPage page = MainTab.TabPages[i];
                HexPanel panel = (HexPanel)page.GetNextControl(page, true);
                if (e.Control)
                {
                    switch (e.KeyValue)
                    {
                        case 33: panel.PosTop();// PgUp
                            break;
                        case 34: panel.PosDown();// PgDn
                            break;
                    }
                }
                else
                {
                    if (!e.Alt)
                    {                        
                        panel.myKeyDown(e.KeyValue);
                    }
                }
            }

        }

      

        private void MnDeleteRegister_Click(object sender, EventArgs e)
        {
            if (MainTab.TabPages.Count > 0) {
                int i = MainTab.SelectedIndex;
                if (i>=0) 
                {
                    MainTab.TabPages.RemoveAt(i);
                }
            }
        }


        private void MnExport2Notepad_Click(object sender, EventArgs e)
        {
            int i = MainTab.SelectedIndex;
            if ((i >= 0) && (MainTab.TabPages.Count > 0))
            {
                SaveFileDialog saveFileDialog1 = new SaveFileDialog();
                saveFileDialog1.Filter = "Textdateien (*.txt)|*.txt|All files (*.*)|*.*";
                saveFileDialog1.FilterIndex = 1;// zählt von 1 !
                saveFileDialog1.DefaultExt = ".txt";
                saveFileDialog1.InitialDirectory = Environment.CurrentDirectory;
                saveFileDialog1.RestoreDirectory = true;
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    TabPage page = MainTab.TabPages[i];
                    HexPanel panel = (HexPanel)page.GetNextControl(page, true);
                    panel.saveToFile(saveFileDialog1.FileName);
                }
            }
        }      


    }
}
